## davix 0.4.0

=== CMakeLists.txt ===

## cmake build script for davix
project (davix)
cmake_minimum_required (VERSION 2.6)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
option(SHARED_LIBRARY "generate shared library" TRUE)
option(STATIC_LIBRARY  "generate static library" FALSE)


# build type
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, default to RelWithDebInfo")
    set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif(NOT CMAKE_BUILD_TYPE)

# load module
include(DefineInstallationPaths REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)
include(PortabilityGNUCheck REQUIRED)
include(CMakeCXX11Support REQUIRED)

#enable testing
INCLUDE(CTest)


set(OUTPUT_NAME_DAVIX "davix")
set(VERSION_MAJOR 0)
set(VERSION_MINOR 4)
set(VERSION_PATCH 0)
set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
set(VERSION_TAG "prod")


# dependency mode
option(BOOST_EXTERNAL "Enable the usage of an external boost dependency" TRUE)
set (Boost_NO_BOOST_CMAKE ON)

# components
option(ENABLE_TOOLS "enable or disable tools " TRUE)

# features
option(ENABLE_IPV6 "enable or disable IPv6 support " TRUE)
option(ENABLE_TCP_NODELAY "enable or disable tcp_nodelay" TRUE)
option(ENABLE_THIRD_PARTY_COPY "enable or disable third party copy support" FALSE)

# tests
option(UNIT_TESTS "enable or disable the unit tests" FALSE)
option(FUNCTIONAL_TESTS "enable or disable the functional tests" FALSE)
option(BENCH_TESTS "enable or disable the bench tests" FALSE)

# libs checks
find_package(Threads)

# openssl
find_package(OpenSSL)
SET(LIBSSL_PKG_LIBRARIES "${OPENSSL_LIBRARIES}")
SET(CRYPTO_PKG "")
SET(LIBSSL_PKG_INCLUDE_DIRS "${OPENSSL_INCLUDE_DIR}")

find_package(LibXml2)
set(LIBXML2_INCLUDE_DIRS ${LIBXML2_INCLUDE_DIR})

if(BOOST_EXTERNAL)
find_package(Boost 1.41.0 COMPONENTS thread system)
endif(BOOST_EXTERNAL)

#const
set(HAVE_OPENSSL 1)
set(NE_HAVE_SSL 1)

add_subdirectory(deps)




## general defs
add_definitions( -D_GNU_SOURCE)              # GNU source, import LFS, etc...
add_definitions( -D__DAVIX_INSIDE__)         # protection flag
add_definitions( -D__STDC_LIMIT_MACROS )     # C99 limit macros


set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_FLAG_ENABLE}")

include_directories( ${Boost_INCLUDE_DIRS})
include_directories( ${HTTPLIB_PKG_INCLUDE_DIRS} ${GLIB2_PKG_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR}/deps ${CMAKE_CURRENT_SOURCE_DIR}/deps/libneon/src/ )
include_directories( ${CMAKE_SOURCE_DIR}/include/davix )
include_directories( ${CMAKE_SOURCE_DIR}/src/libs/)

add_subdirectory (src)
add_subdirectory (doc)
add_subdirectory (dist)
add_subdirectory (test)
add_subdirectory (packaging)


#############################################################################
## headers

install(DIRECTORY ${CMAKE_SOURCE_DIR}/include/davix/
                DESTINATION ${INCLUDE_INSTALL_DIR}/davix)

##############################################################################
## Doc file
install(FILES RELEASE-NOTES LICENSE
                DESTINATION ${DOC_INSTALL_DIR}/) # install release notes


#######################################################
# Configure an 'uninstall' target
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== src/tools/CMakeLists.txt ===
# main file for command line tools
#




LIST(APPEND davix_main_src "davix_tool_main.cpp")
LIST(APPEND davix_ls_main_src "davix_tool_ls_main.cpp")
LIST(APPEND davix_get_main_src "davix_tool_get_main.cpp")
LIST(APPEND davix_put_main_src "davix_tool_put_main.cpp")
LIST(APPEND davix_rm_main_src "davix_tool_rm_main.cpp")
LIST(APPEND davix_mkcol_main_src "davix_tool_mkcol_main.cpp")
LIST(APPEND davix_mv_main_src "davix_tool_mv_main.cpp")
LIST(APPEND davix_copy_main_src "davix_tool_copy_main.cpp")
LIST(APPEND davix_tool_common_src "${CMAKE_CURRENT_SOURCE_DIR}/davix_tool_params.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/davix_tool_util.cpp" "${SRC_SIMPLE_GET_PASS}")
SET(davix_tool_common_src_up "${davix_tool_common_src}" PARENT_SCOPE)

link_directories(${PROJECT_BINARY_DIR}/src/)


add_definitions(-DNO_BOOST_INCLUDE)

## rt link
set(RT_LIBRARIES "")
if(HAVE_CLOCK_GETTIME)
    set(RT_LIBRARIES "rt")
endif(HAVE_CLOCK_GETTIME)

## davix tool lib
add_library(davix_tool_lib STATIC ${davix_tool_common_src})


## davix cmd line
add_executable(davix_tool ${davix_main_src})

target_link_libraries(davix_tool davix_tool_lib davix ${RT_LIBRARIES})
set_target_properties(davix_tool PROPERTIES
                                OUTPUT_NAME "davix-http")
add_dependencies(davix_tool libdavix)

## davix ls cmd line
add_executable(davix_ls_tool ${davix_ls_main_src})

target_link_libraries(davix_ls_tool davix_tool_lib davix ${RT_LIBRARIES})
set_target_properties(davix_ls_tool PROPERTIES
                                OUTPUT_NAME "davix-ls")
add_dependencies(davix_ls_tool libdavix)


## davix get cmd line
add_executable(davix_get_tool ${davix_get_main_src})

target_link_libraries(davix_get_tool davix_tool_lib davix ${RT_LIBRARIES})
set_target_properties(davix_get_tool PROPERTIES
                                OUTPUT_NAME "davix-get")
add_dependencies(davix_get_tool libdavix)

## davix put cmd line
add_executable(davix_put_tool ${davix_put_main_src})

target_link_libraries(davix_put_tool davix_tool_lib davix ${RT_LIBRARIES})
set_target_properties(davix_put_tool PROPERTIES
                                OUTPUT_NAME "davix-put")
add_dependencies(davix_put_tool libdavix)


## davix del cmd line
add_executable(davix_mkdir_tool ${davix_mkcol_main_src})

target_link_libraries(davix_mkdir_tool davix_tool_lib davix ${RT_LIBRARIES})
set_target_properties(davix_mkdir_tool PROPERTIES
                                OUTPUT_NAME "davix-mkdir")
add_dependencies(davix_mkdir_tool libdavix)

## davix rm cmd line
add_executable(davix_rm_tool ${davix_rm_main_src})

target_link_libraries(davix_rm_tool davix_tool_lib davix ${RT_LIBRARIES})
set_target_properties(davix_rm_tool PROPERTIES
                                OUTPUT_NAME "davix-rm")
add_dependencies(davix_rm_tool libdavix)

## davix mv cmd line
add_executable(davix_mv_tool ${davix_mv_main_src})

target_link_libraries(davix_mv_tool davix_tool_lib davix ${RT_LIBRARIES})
set_target_properties(davix_mv_tool PROPERTIES
                                OUTPUT_NAME "davix-mv")
add_dependencies(davix_mv_tool libdavix)
    


install(TARGETS davix_tool davix_ls_tool davix_get_tool davix_put_tool davix_mkdir_tool davix_rm_tool davix_mv_tool
         DESTINATION ${BIN_INSTALL_DIR}/)

## davix cp cmd line
if (ENABLE_THIRD_PARTY_COPY)

    add_executable(davix_cp_tool ${davix_copy_main_src})

    target_link_libraries(davix_cp_tool davix_copy davix_tool_lib ${RT_LIBRARIES})
    set_target_properties(davix_cp_tool PROPERTIES
                                OUTPUT_NAME "davix-cp")
    add_dependencies(davix_cp_tool davix_copy)
    
    install(TARGETS davix_cp_tool
            DESTINATION ${BIN_INSTALL_DIR}/)
    
endif (ENABLE_THIRD_PARTY_COPY)

=== test/unit/CMakeLists.txt ===
# main file for src

if(UNIT_TESTS)

include_directories(${PROJECT_SOURCE_DIR}/src "." ${GTEST_INCLUDE_DIRS})
include_directories(${HEADER_RAPIDJSON})


## alibxx


file(GLOB src_alibxx alibxx/*.cpp)
file(GLOB src_neon neon/*.cpp)
file(GLOB src_datetime datetime/*.cpp)
file(GLOB src_credential credential/*.cpp)
file(GLOB src_context context/*.cpp)
file(GLOB src_session session/*.cpp)
file(GLOB src_parser xmlparser/*.cpp)
file(GLOB src_files files/*.cpp)
file(GLOB src_auth  auth/*.cpp)
LIST(APPEND src_utils utils/utils_test.cpp ${SRC_STRING_UTILS_CPP})
LIST(APPEND src_parser parser/parser_test.cpp)
LIST(APPEND src_httprequest sessionfactory/test_factory.cpp)


add_definitions( -DTEST_VALID_CERT="${TEST_CRED_PATH}" -DTEST_VALID_CERT_PASS="${TEST_CRED_PASS}")
add_executable(g_test_unit_davix_exe ${src_context} ${src_session} ${src_credential}
                ${src_httprequest} ${src_datetime} ${src_neon} ${src_parser} ${src_auth} ${src_utils} ${src_parser} ${SRC_BASE64}
                ${SRC_HMACSHA1} ${davix_tool_common_src} ${src_files} ${src_alibxx})

target_link_libraries(g_test_unit_davix_exe alibxx_core davix  gtest gtest_main ${LIBSSL_PKG_LIBRARIES} ${Boost_LIBRARIES})

if(HAVE_CLOCK_GETTIME)
    target_link_libraries(g_test_unit_davix_exe rt)
endif(HAVE_CLOCK_GETTIME)

add_dependencies(g_test_unit_davix_exe libdavix)



add_test(g_test_unit_davix g_test_unit_davix_exe )

endif(UNIT_TESTS)

=== deps/boost_intern/src/CMakeLists.txt ===


## boost
if(NOT Boost_FOUND)

FILE(GLOB BOOST_SRC_SYSTEM "${CMAKE_CURRENT_SOURCE_DIR}/system/src/*.cpp")
FILE(GLOB BOOST_SRC_THREAD "${CMAKE_CURRENT_SOURCE_DIR}/thread/src/pthread/*.cpp")


LIST(APPEND SRC_BOOST_ALL ${BOOST_SRC_THREAD} ${BOOST_SRC_SYSTEM})

SET(SRC_BOOST_ALL ${SRC_BOOST_ALL} PARENT_SCOPE)

include_directories("${CMAKE_CURRENT_SOURCE_DIR}/../ ")
add_definitions( -DBOOST_THREAD_BUILD_LIB=1)
add_definitions( -DBOOST_THREAD_POSIX )
add_definitions( -fPIC )
add_definitions(-fvisibility=hidden)
add_library(boost_static_internal STATIC ${SRC_BOOST_ALL})

# if the static library is produced, then we need also to install the dependent libraries to be useful
if(STATIC_LIBRARY)
  install(TARGETS boost_static_internal DESTINATION ${LIB_INSTALL_DIR} )
endif()

endif(NOT Boost_FOUND)

=== src/libs/alibxx/CMakeLists.txt ===
# libs CMakefile for A_LIB_NAMESPACE


SET(ALIBXX_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE STRING "ALIBXX src dir")


FILE(GLOB src_alibxx "${CMAKE_CURRENT_SOURCE_DIR}/*/*.cpp")

add_definitions( -fPIC)
add_library(alibxx_core STATIC ${src_alibxx})

=== src/modules/copy/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

IF (ENABLE_THIRD_PARTY_COPY)
    INCLUDE     (CheckLibraryExists)

    pkg_check_modules(GSOAP_SSL_PKG    REQUIRED "gsoapssl++")
    find_package(GRIDSITE REQUIRED)
    
    FIND_PACKAGE(gSOAP REQUIRED)
    MESSAGE(STATUS "Using gsoapssl flags ${GSOAP_SSL_PKG_CFLAGS}")
    
    # Compile the WSDL for 1.1.0
    ADD_CUSTOM_COMMAND (OUTPUT typemap.dat
                        COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/delegation/typemap.dat ${CMAKE_CURRENT_BINARY_DIR}/typemap.dat)
                        
    ADD_CUSTOM_COMMAND (
        OUTPUT delegation1.h
        COMMAND ${GSOAP_WSDL2H} -j -s -I/usr/share/gsoap/import/ -o${CMAKE_CURRENT_BINARY_DIR}/delegation1.h ${CMAKE_CURRENT_SOURCE_DIR}/delegation/delegation-1.1.0.wsdl -qdelegation1
        DEPENDS typemap.dat)
    ADD_CUSTOM_COMMAND (
        OUTPUT delegation1C.cpp delegation1Client.cpp
        COMMAND ${GSOAP_SOAPCPP2} -L -C -x -w -I/usr/share/gsoap/import/ ${CMAKE_CURRENT_BINARY_DIR}/delegation1.h -pdelegation1 -qdelegation1
        DEPENDS delegation1.h)
                        
    # Compile the WSDL for 2.0.0
    ADD_CUSTOM_COMMAND (
        OUTPUT delegation2.h
        COMMAND ${GSOAP_WSDL2H} -j -s -I/usr/share/gsoap/import/ -o${CMAKE_CURRENT_BINARY_DIR}/delegation2.h ${CMAKE_CURRENT_SOURCE_DIR}/delegation/delegation-2.0.0.wsdl -qdelegation2
        DEPENDS typemap.dat)
    ADD_CUSTOM_COMMAND (
        OUTPUT delegation2C.cpp delegation2Client.cpp
        COMMAND ${GSOAP_SOAPCPP2} -C -x -w -I/usr/share/gsoap/import/ ${CMAKE_CURRENT_BINARY_DIR}/delegation2.h -n
        DEPENDS delegation2.h)
                        
    # Need to generate some utility functions in the global namespace
    ADD_CUSTOM_COMMAND (OUTPUT env.h
                        COMMAND touch env.h)
    ADD_CUSTOM_COMMAND (OUTPUT envC.cpp
                        COMMAND ${GSOAP_SOAPCPP2}  ${CMAKE_CURRENT_BINARY_DIR}/env.h -penv
                        DEPENDS env.h)
                        
    # Includes
    INCLUDE_DIRECTORIES (${CMAKE_CURRENT_BINARY_DIR}
                         ${GRIDSITE_INCLUDE_DIR}
                         ${GSOAP_INCLUDE_DIR})
                         
    # link
    LINK_DIRECTORIES( ${DAVIX_PKG_LIBRARY_DIRS})
    ADD_DEFINITIONS(${GSOAP_SSL_PKG_CFLAGS} ${GRIDSITE_DEFINITIONS})
    
    # Build third party copy as a static library
    FILE(GLOB src_copy "*.cpp")
    FILE(GLOB src_dlg "delegation/*.cpp")
    
    ADD_LIBRARY (davix_copy SHARED ${src_copy} ${src_dlg}
                           ${CMAKE_CURRENT_BINARY_DIR}/delegation1C.cpp
                           ${CMAKE_CURRENT_BINARY_DIR}/delegation1Client.cpp
                           ${CMAKE_CURRENT_BINARY_DIR}/delegation2C.cpp
                           ${CMAKE_CURRENT_BINARY_DIR}/delegation2Client.cpp
                           ${CMAKE_CURRENT_BINARY_DIR}/envC.cpp)
                                   
    TARGET_LINK_LIBRARIES(davix_copy libdavix
                                     ${GSOAP_SSL_PKG_LIBRARIES}
                                     ${GRIDSITE_LIBRARIES})
                                     
    SET_TARGET_PROPERTIES(davix_copy PROPERTIES
                            VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                            SOVERSION ${VERSION_MAJOR}
                            CLEAN_DIRECT_OUTPUT 1
                            OUTPUT_NAME "davix_copy")

    INSTALL(TARGETS davix_copy
             DESTINATION ${LIB_INSTALL_DIR})
             
    add_PkgConfigFile_for_Library("davix_copy.pc" davix_copy
                               HEADER_DIRS "davix"
                               CFLAGS " -D_FILE_OFFSET_BITS=64 "
                               DESCRIPTION "Davix, High level WebDav/HTTP library. Third party copy library."
                               )
                               
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/davix_copy.pc
            DESTINATION ${PKGCONFIG_FILES_DIR})

ENDIF (ENABLE_THIRD_PARTY_COPY)

=== debian/changelog ===
davix (0.4.0-1) unstable; urgency=medium

  * Update to version 0.4.0

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Mon, 08 Dec 2014 16:31:16 +0100

davix (0.3.6-1) unstable; urgency=medium

  * Update to version 0.3.6

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Thu, 23 Oct 2014 16:02:47 +0200

=== debian/control ===
Source: davix
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@fysast.uu.se>
Build-Depends: debhelper (>= 8.0.0), cmake, libxml2-dev, libssl-dev, gsoap, libgridsite-dev, libboost-system-dev, libboost-thread-dev, rapidjson-dev, libgtest-dev, abi-compliance-checker, pkg-config, doxygen
Standards-Version: 3.9.6
Section: net
Homepage: http://dmc.web.cern.ch/projects/davix/home

Package: davix
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdavix0 (= ${binary:Version})
Description: Toolkit for http based file management
 Davix is a toolkit designed for file operations with http based protocols
 (WebDav, Amazon S3, ...).

Package: libdavix0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Runtime library for davix
 Library for davix. Davix is a toolkit designed for file operations with
 http based protocols (WebDav, Amazon S3, ...).

Package: davix-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdavix0 (= ${binary:Version})
Description: Development files for davix
 Development files for davix. Davix is a toolkit designed for file operations
 with http based protocols (WebDav, Amazon S3, ...).

Package: davix-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation for davix
 Documentation and examples for davix. Davix is a toolkit designed for file
 operations with Http based protocols (WebDav, Amazon S3, ...).

## davix 0.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,9 +29,9 @@
 set(OUTPUT_NAME_DAVIX "davix")
 set(VERSION_MAJOR 0)
 set(VERSION_MINOR 4)
-set(VERSION_PATCH 0)
+set(VERSION_PATCH 1)
 set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
-set(VERSION_TAG "prod")
+set(VERSION_TAG "")
 
 
 # dependency mode

=== src/CMakeLists.txt ===
# main file for src


FILE(GLOB src_davix "*.cpp")

FILE(GLOB src_neon "neon/*.cpp")
FILE(GLOB src_davix_status "status/*.cpp")
FILE(GLOB src_davix_fileops "fileops/*.cpp")
FILE(GLOB src_davix_params "params/*.cpp")
FILE(GLOB src_davix_auth "auth/*.cpp")
FILE(GLOB src_davix_file "file/*.cpp")
FILE(GLOB src_davix_deprecated "deprecated/*.cpp")
FILE(GLOB src_davix_request "request/*.cpp")
FILE(GLOB src_davix_hooks "hooks/*.cpp")
FILE(GLOB src_davix_modules "modules/*.cpp")
FILE(GLOB src_davix_utils "utils/*.cpp")


include_directories("libs" ".")

if(HAVE_TR1_SUPPORT)

endif(HAVE_TR1_SUPPORT)

configure_file(davix_internal_config.in ${CMAKE_CURRENT_BINARY_DIR}/davix_internal_config.hpp @ONLY)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
link_directories(${HTTPLIB_PKG_LIBRARY_DIR} ${CRYPTO_PKG_LIBRARY_DIR} 
                                        ${LIBXML2_PKG_LIBRARY_DIR} )

add_subdirectory(modules/copy)
add_subdirectory(libs)
add_subdirectory(xml)
if(ENABLE_TOOLS)
  add_subdirectory(tools)
endif()

add_subdirectory(neon)
SET(SRC_HTTP ${src_neon})

LIST(APPEND SRC_DAVIX_FULL ${src_davix} ${src_davix_request} ${SRC_HTTP}  ${src_xmlparser} ${src_datetime}
                           ${src_davix_status} ${src_davix_fileops} ${src_davix_utils}
                           ${src_davix_params} ${src_davix_auth} ${src_davix_file} ${src_davix_deprecated} ${src_davix_hooks} ${src_davix_modules} ${SRC_STRPTIME} ${SRC_MEMPCPY}
                           ${SRC_STRLCPY} ${SRC_STRING_UTILS_CPP} ${SRC_BASE64} ${SRC_HMACSHA1} )


add_definitions(${HTTPLIB_PKG_CFLAGS} )

if(SHARED_LIBRARY)
add_library(libdavix  SHARED ${SRC_DAVIX_FULL} )
add_dependencies(libdavix neon)


target_link_libraries(libdavix  alibxx_core ${HTTPLIB_PKG_LIBRARIES} ${CRYPTO_PKG_LIBRARIES}
                                ${CMAKE_THREAD_LIBS_INIT} ${SOCKET_PKG_LIBRARIES} ${Boost_LIBRARIES})

if(HAVE_CLOCK_GETTIME)
    target_link_libraries(libdavix rt)
endif(HAVE_CLOCK_GETTIME)


set_target_properties(libdavix PROPERTIES
                            VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                            SOVERSION ${VERSION_MAJOR}
                            CLEAN_DIRECT_OUTPUT 1
                            OUTPUT_NAME ${OUTPUT_NAME_DAVIX})

install(TARGETS libdavix
             DESTINATION ${LIB_INSTALL_DIR} )

add_PkgConfigFile_for_Library("davix.pc" libdavix
                               HEADER_DIRS "davix"
                               CFLAGS " -D_FILE_OFFSET_BITS=64 "
                               DESCRIPTION "Libdavix, IO library for HTTP based protocols"
                               )
#install pkgconfig
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/davix.pc
        DESTINATION ${PKGCONFIG_FILES_DIR} )

endif(SHARED_LIBRARY)



if(STATIC_LIBRARY)

add_library(libdavix_static  STATIC ${SRC_DAVIX_FULL})


set_target_properties(libdavix_static PROPERTIES
                            OUTPUT_NAME ${OUTPUT_NAME_DAVIX})


install(TARGETS libdavix_static
             DESTINATION ${LIB_INSTALL_DIR} )

endif(STATIC_LIBRARY)

SET(davix_tool_common_src "${davix_tool_common_src_up}" PARENT_SCOPE)

=== src/tools/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 LIST(APPEND davix_mkcol_main_src "davix_tool_mkcol_main.cpp")
 LIST(APPEND davix_mv_main_src "davix_tool_mv_main.cpp")
 LIST(APPEND davix_copy_main_src "davix_tool_copy_main.cpp")
-LIST(APPEND davix_tool_common_src "${CMAKE_CURRENT_SOURCE_DIR}/davix_tool_params.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/davix_tool_util.cpp" "${SRC_SIMPLE_GET_PASS}")
+LIST(APPEND davix_tool_common_src "${CMAKE_CURRENT_SOURCE_DIR}/davix_tool_params.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/davix_tool_util.cpp" "${SRC_SIMPLE_GET_PASS}" "${CMAKE_CURRENT_SOURCE_DIR}/davix_op.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/davix_taskqueue.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/davix_thread.cpp" "${CMAKE_CURRENT_SOURCE_DIR}/davix_thread_pool.cpp")
 SET(davix_tool_common_src_up "${davix_tool_common_src}" PARENT_SCOPE)
 
 link_directories(${PROJECT_BINARY_DIR}/src/)
@@ -25,6 +25,7 @@
 if(HAVE_CLOCK_GETTIME)
     set(RT_LIBRARIES "rt")
 endif(HAVE_CLOCK_GETTIME)
+
 
 ## davix tool lib
 add_library(davix_tool_lib STATIC ${davix_tool_common_src})
@@ -50,7 +51,7 @@
 ## davix get cmd line
 add_executable(davix_get_tool ${davix_get_main_src})
 
-target_link_libraries(davix_get_tool davix_tool_lib davix ${RT_LIBRARIES})
+target_link_libraries(davix_get_tool davix_tool_lib davix pthread ${RT_LIBRARIES})
 set_target_properties(davix_get_tool PROPERTIES
                                 OUTPUT_NAME "davix-get")
 add_dependencies(davix_get_tool libdavix)
@@ -58,7 +59,7 @@
 ## davix put cmd line
 add_executable(davix_put_tool ${davix_put_main_src})
 
-target_link_libraries(davix_put_tool davix_tool_lib davix ${RT_LIBRARIES})
+target_link_libraries(davix_put_tool davix_tool_lib davix pthread ${RT_LIBRARIES})
 set_target_properties(davix_put_tool PROPERTIES
                                 OUTPUT_NAME "davix-put")
 add_dependencies(davix_put_tool libdavix)

=== debian/changelog ===
davix (0.4.1-2) unstable; urgency=medium

  * Rename libdavix0 to libdavix0v5 for GCC 5 abi change - based on
    patch from Ubuntu (Closes: #791021, #793228)
  * Add Replaces/Breaks on the old library package name

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Thu, 13 Aug 2015 12:05:40 +0200

davix (0.4.1-1) unstable; urgency=medium

  * Update to version 0.4.1
  * Implement Multi-Arch support

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Fri, 31 Jul 2015 13:17:55 +0200

=== debian/control ===
--- 
+++ 
@@ -8,14 +8,18 @@
 
 Package: davix
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libdavix0 (= ${binary:Version})
+Multi-Arch: foreign
+Depends: ${shlibs:Depends}, ${misc:Depends}, libdavix0v5 (= ${binary:Version})
 Description: Toolkit for http based file management
  Davix is a toolkit designed for file operations with http based protocols
  (WebDav, Amazon S3, ...).
 
-Package: libdavix0
+Package: libdavix0v5
 Section: libs
 Architecture: any
+Multi-Arch: same
+Replaces: libdavix0 (<< 0.4.1-2~)
+Breaks: libdavix0 (<< 0.4.1-2~)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Runtime library for davix
  Library for davix. Davix is a toolkit designed for file operations with
@@ -24,7 +28,8 @@
 Package: davix-dev
 Section: libdevel
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libdavix0 (= ${binary:Version})
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}, libdavix0v5 (= ${binary:Version})
 Description: Development files for davix
  Development files for davix. Davix is a toolkit designed for file operations
  with http based protocols (WebDav, Amazon S3, ...).
@@ -32,6 +37,7 @@
 Package: davix-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Documentation for davix
  Documentation and examples for davix. Davix is a toolkit designed for file

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/dpkg/buildflags.mk

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

export CFLAGS CXXFLAGS LDFLAGS

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	# Remove bundled stuff
	rm -rf deps/boost_intern
	rm -rf deps/rapidjson
	rm -rf deps/strptime
	rm -rf test/pywebdav
	# Debian's gtest is not precompiled - link source
	ln -fs /usr/src/gtest test/unit/gtest
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
		-DUNIT_TESTS=TRUE \
		-DENABLE_THIRD_PARTY_COPY=TRUE

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_install:
	rm debian/tmp/usr/share/doc/davix/LICENSE
	dh_install --fail-missing

override_dh_auto_clean:
	rm -f test/unit/gtest
	dh_auto_clean

override_dh_auto_test:
	( cd obj-* ; make abi-check )
	dh_auto_test -- ARGS+="-V -T Test"

## davix 0.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,8 +28,8 @@
 
 set(OUTPUT_NAME_DAVIX "davix")
 set(VERSION_MAJOR 0)
-set(VERSION_MINOR 4)
-set(VERSION_PATCH 1)
+set(VERSION_MINOR 5)
+set(VERSION_PATCH 0)
 set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 set(VERSION_TAG "")

=== deps/CMakeLists.txt ===
###
## compile dependencies of davix


IF(NOT HAVE_STRPTIME_H)
    SET(SRC_STRPTIME "${CMAKE_CURRENT_SOURCE_DIR}/strptime/strptime.c" PARENT_SCOPE)
ELSE(NOT HAVE_STRPTIME_H)
    SET(SRC_STRPTIME "" PARENT_SCOPE)
ENDIF(NOT HAVE_STRPTIME_H)


SET(SRC_SIMPLE_GET_PASS "${CMAKE_CURRENT_SOURCE_DIR}/simple_getpass/simple_get_pass.cpp" PARENT_SCOPE)
SET(SRC_STRING_UTILS_CPP "${CMAKE_CURRENT_SOURCE_DIR}/string_utils/stringutils.cpp" PARENT_SCOPE)


#json parser
SET(HEADER_RAPIDJSON "${CMAKE_CURRENT_SOURCE_DIR}/rapidjson/include" PARENT_SCOPE)


## boost
if(NOT Boost_FOUND)
SET(Boost_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/boost_intern" PARENT_SCOPE)

add_subdirectory(boost_intern/src)
set(Boost_LIBRARIES boost_static_internal PARENT_SCOPE)
endif(NOT Boost_FOUND)

add_subdirectory(libneon)


if(NOT HAVE_SYSSOCKET_H)
set(SOCKET_PKG_LIBRARIES "ws2_32")
endif(NOT HAVE_SYSSOCKET_H)

SET(HTTPLIB_PKG_VERSION "0.29.0" PARENT_SCOPE)
SET(HTTPLIB_PKG_STATIC_LIB_PATH "${CMAKE_CURRENT_BINARY_DIR}/libneon/src/libneon.a")
SET(HTTPLIB_PKG_LIBRARIES ${HTTPLIB_PKG_STATIC_LIB_PATH} ${LIBSSL_PKG_LIBRARIES} ${LIBGSSAPI_PKG_LIBRARIES} ${LIBXML2_LIBRARIES} ${SOCKET_PKG_LIBRARIES} PARENT_SCOPE)
SET(HTTPLIB_PKG_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/libneon/src/  ${LIBXML2_INCLUDE_DIRS} ${LIBSSL_PKG_INCLUDE_DIRS}  ${LIBGSSAPI_PKG_INCLUDE_DIRS} PARENT_SCOPE)

=== doc/CMakeLists.txt ===



file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/build/html/")
addDoxyGeneration("Doxyfile.in")
SET( l_doc "${CMAKE_CURRENT_BINARY_DIR}/build/html/")

install(DIRECTORY ${l_doc}
		DESTINATION ${DOC_INSTALL_DIR}/html/) # install examples 


FILE(GLOB man1_page ${CMAKE_CURRENT_SOURCE_DIR}/man/*.1)
install(FILES ${man1_page}
                        DESTINATION ${MAN_INSTALL_DIR}/man1/)
                        
FILE(GLOB man3_page ${CMAKE_CURRENT_SOURCE_DIR}/man/*.3)
install(FILES ${man3_page}
                        DESTINATION ${MAN_INSTALL_DIR}/man3/)

=== packaging/CMakeLists.txt ===
# configure packaging files

configure_file (
               "${CMAKE_CURRENT_SOURCE_DIR}/rpm/specs/davix.spec.in"
               "${CMAKE_CURRENT_SOURCE_DIR}/rpm/specs/davix.spec"
               @ONLY
)

=== packaging/Makefile ===
NAME=davix
SPEC=rpm/specs/$(NAME).spec
VERSION=${shell grep '^Version:' $(SPEC) | awk '{print $$2}' }
# Leave blank. To be overriden by CI tools.
RELEASE=

CWD=${shell pwd}

RPMBUILD=/tmp/rpmbuild
SRPMS=$(CWD)
RPMS=$(CWD)/out

MOCK_CHROOT=epel-6-cernonly-x86_64
MOCK_FLAGS=--verbose


RPMDEFINES_SRC=--define='_topdir $(RPMBUILD)' \
	--define='_sourcedir $(CWD)' \
	--define='_builddir %{_topdir}/BUILD' \
	--define='_srcrpmdir $(SRPMS)' \
	--define='_rpmdir $(RPMS)' \
    --define "_source_filedigest_algorithm md5" \
    $(RPMBUILD_SRC_EXTRA_FLAGS)

RPMDEFINES_BIN=--define='_topdir $(RPMBUILD)' \
	--define='_sourcedir %{_topdir}/SOURCES' \
	--define='_builddir %{_topdir}/BUILD' \
	--define='_srcrpmdir $(SRPMS).' \
	--define='_rpmdir $(RPMS)' \
    --define "_binary_filedigest_algorithm md5" \
    $(RPMBUILD_BIN_EXTRA_FLAGS)


PBUILDER_FLAGS=
PBUILDER_TMP="/tmp/"


all: srpm

clean:
	rm -fv *.tar
	rm -fv *.tar.gz
	rm -fv *.rpm
	rm -fv *.log
	rm -rfv out
	rm -fv *.deb
	rm -fv *.xz
	rm -fv *.dsc
	rm -fv *.changes
	rm -rfv "$(RPMBUILD)"

dist: clean
	tar vczf "$(NAME)-$(VERSION).tar.gz" --exclude="*.rpm" --exclude="*.gz" --exclude=".git" --exclude="*.pyc" --transform="s,^,$(NAME)-$(VERSION)/," ..

$(RPMBUILD):
	mkdir -p "$(RPMBUILD)"

override_release: $(SPEC)
	$(if $(RELEASE), sed -i "s/Release:.*/Release: $(RELEASE)/g" "$(SPEC)")

srpm: dist $(SPEC) $(RPMBUILD) override_release
	/usr/bin/rpmbuild --nodeps -bs $(RPMDEFINES_SRC) $(SPEC)

rpm: srpm
	/usr/bin/rpmbuild --rebuild $(RPMDEFINES_BIN) $(NAME)-$(VERSION)-*.src.rpm

mock: srpm
	/usr/bin/mock $(MOCK_FLAGS) -r $(MOCK_CHROOT) $(NAME)-$(VERSION)-*.src.rpm

deb-src: dist
	rm -rf "$(PBUILDER_TMP)/$(NAME)-$(VERSION)"
	tar xzf "$(NAME)-$(VERSION).tar.gz" -C "$(PBUILDER_TMP)"
	cp -rv debian "$(PBUILDER_TMP)/$(NAME)-$(VERSION)"
	$(if $(RELEASE), sed -ri "s/($(NAME) )\((([0-9]+\.)+[0-9]+)-[0-9]+\)/\\1(\\2-$(RELEASE))/g" "$(PBUILDER_TMP)/$(NAME)-$(VERSION)/debian/changelog")
	cp -f "$(NAME)-$(VERSION).tar.gz" "$(PBUILDER_TMP)/$(NAME)_$(VERSION).orig.tar.gz" 
	cd "$(PBUILDER_TMP)/$(NAME)-$(VERSION)"; \
		debuild -us -uc -S
	mv $(PBUILDER_TMP)/$(NAME)_$(VERSION)*.gz .
	mv $(PBUILDER_TMP)/$(NAME)_$(VERSION)*.xz .
	mv $(PBUILDER_TMP)/$(NAME)_$(VERSION)*.dsc .

deb: deb-src
	pbuilder build $(PBUILDER_FLAGS) $(NAME)_$(VERSION)*.dsc

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -83,8 +83,9 @@
 
 if(STATIC_LIBRARY)
 
-add_library(libdavix_static  STATIC ${SRC_DAVIX_FULL})
-
+add_definitions(-DA_LIB_NAMESPACE=Davix)
+FILE(GLOB src_alibxx_static "libs/alibxx/*/*.cpp")
+add_library(libdavix_static  STATIC ${SRC_DAVIX_FULL} ${src_alibxx_static})
 
 set_target_properties(libdavix_static PROPERTIES
                             OUTPUT_NAME ${OUTPUT_NAME_DAVIX})

=== deps/libneon/CMakeLists.txt ===
project(libneon-tuned)
cmake_minimum_required (VERSION 2.6)
# main file for src

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

# load module
include(ReleaseDebugAutoFlags REQUIRED)
include(PortabilityGNUCheck REQUIRED)
set(OUTPUT_NAME_DAVIX "neon")
set(VERSION_MAJOR 0)
set(VERSION_MINOR 0)
set(VERSION_PATCH 29)
set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

find_package(SOCKET)

find_package(LibXml2)
if(LIBXML2_INCLUDE_DIR)
set(HAVE_LIBXML 1)
endif(LIBXML2_INCLUDE_DIR)

set(HAVE_IPV6 ${ENABLE_IPV6})
set(TCP_NODELAY ${ENABLE_TCP_NODELAY})

configure_file(config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ 
                    ${LIBXML2_INCLUDE_DIR} ${OPENSSL_INCLUDE_DIR})

add_definitions(  -std=gnu99 -fPIC -DNEON_VERSION="${VERSION_STRING}" -DNE_VERSION_MAJOR=${VERSION_MAJOR}  -DNE_VERSION_MINOR=${VERSION_MINOR} -Wno-unused-parameter)
add_definitions( -fvisibility=hidden)



add_subdirectory(src)

=== src/neon/CMakeLists.txt ===
# main file for src

=== src/tools/CMakeLists.txt ===
--- 
+++ 
@@ -42,7 +42,7 @@
 ## davix ls cmd line
 add_executable(davix_ls_tool ${davix_ls_main_src})
 
-target_link_libraries(davix_ls_tool davix_tool_lib davix ${RT_LIBRARIES})
+target_link_libraries(davix_ls_tool davix_tool_lib davix ${CMAKE_THREAD_LIBS_INIT} ${RT_LIBRARIES})
 set_target_properties(davix_ls_tool PROPERTIES
                                 OUTPUT_NAME "davix-ls")
 add_dependencies(davix_ls_tool libdavix)
@@ -51,7 +51,7 @@
 ## davix get cmd line
 add_executable(davix_get_tool ${davix_get_main_src})
 
-target_link_libraries(davix_get_tool davix_tool_lib davix pthread ${RT_LIBRARIES})
+target_link_libraries(davix_get_tool davix_tool_lib davix pthread ${CMAKE_THREAD_LIBS_INIT} ${RT_LIBRARIES})
 set_target_properties(davix_get_tool PROPERTIES
                                 OUTPUT_NAME "davix-get")
 add_dependencies(davix_get_tool libdavix)
@@ -59,7 +59,7 @@
 ## davix put cmd line
 add_executable(davix_put_tool ${davix_put_main_src})
 
-target_link_libraries(davix_put_tool davix_tool_lib davix pthread ${RT_LIBRARIES})
+target_link_libraries(davix_put_tool davix_tool_lib davix pthread ${CMAKE_THREAD_LIBS_INIT} ${RT_LIBRARIES})
 set_target_properties(davix_put_tool PROPERTIES
                                 OUTPUT_NAME "davix-put")
 add_dependencies(davix_put_tool libdavix)
@@ -76,7 +76,7 @@
 ## davix rm cmd line
 add_executable(davix_rm_tool ${davix_rm_main_src})
 
-target_link_libraries(davix_rm_tool davix_tool_lib davix ${RT_LIBRARIES})
+target_link_libraries(davix_rm_tool davix_tool_lib davix ${CMAKE_THREAD_LIBS_INIT} ${RT_LIBRARIES})
 set_target_properties(davix_rm_tool PROPERTIES
                                 OUTPUT_NAME "davix-rm")
 add_dependencies(davix_rm_tool libdavix)

=== test/bench/CMakeLists.txt ===
# main file for src

if(BENCH_TESTS)

LIST(APPEND src_davix_bench "davix_bench.cpp" "chunk_queue.cpp")

#include_directories(/usr/include/davix)

add_executable(davix-bench ${src_davix_bench})
target_link_libraries(davix-bench libdavix ${CMAKE_THREAD_LIBS_INIT})

function(test_read url opt input)
    add_test(test_bench_read_${url} davix-bench ${opt} ${url} ${input})
endfunction(test_read url opt)

function(test_vector_read url opt input)
    add_test(test_bench_vector_read_${url} davix-bench ${opt} ${url} ${input})
endfunction(test_vector_read url opt)

function(test_thread_read url opt input)
    add_test(test_bench_thread_read_${url} davix-bench ${opt} ${url} ${input})
endfunction(test_thread_read url opt)

function(test_write url opt input)
    add_test(test_bench_write_${url} davix-bench ${opt} ${url} ${input})
endfunction(test_write url opt)

include(ctest_bench.cmake)

endif(BENCH_TESTS)

=== test/functional/CMakeLists.txt ===
# main file for src


if(FUNCTIONAL_TESTS)

set(src_davix_test_lib "davix_test_lib.cpp")

set( src_test_req "test_request.cpp")
set( src_test_prop "test_propfind.cpp")
set( src_test_stat "test_stat.cpp" )
set( src_test_mkdir "test_mkdir.cpp")
set( src_test_checksum "test_checksum.cpp")
set( src_test_stat_session "test_stat_session.cpp")
set( src_test_rw "davix_rw_test.cpp")
set( src_test_opendir "test_opendir.cpp")
set( src_test_opendir_partial "test_opendir_partial.cpp")
set( src_test_opendirpp "test_opendirpp.cpp")
set( src_test_listing "test_listing.cpp")
set( src_test_directory "test_directory.cpp")
set( src_test_auto_stat_mkdir_check "test_auto_stat_mkdir_check.cpp")
set( src_test_auto_rmdir_unlink_delete "test_auto_rmdir_unlink_delete.cpp")
set( src_test_valid_read_generic_simple "test_valid_read_generic_simple.cpp")
set( src_test_valid_write_read_generic_simple "test_valid_write_read_generic_simple.cpp")
set( src_test_valid_write_read_davfile "test_valid_write_read_davfile.cpp")
set( src_test_valid_write_read_fd "test_valid_write_read_fd.cpp")
set( src_test_valid_write_read_vector_simple "test_valid_write_read_vector_simple.cpp")
set( src_tool_read_vector_simple "tool_read_vector_simple.cpp")
set( src_tool_get_replicas "tool_get_replica_simple.cpp")
set( src_test_mv "test_mv.cpp")


add_library(test_davix_functional_lib STATIC ${src_davix_test_lib})

add_executable(test_request ${src_test_req} )
target_link_libraries(test_request davix  test_davix_functional_lib)

add_executable(tool_read_vector_simple ${src_tool_read_vector_simple} )
target_link_libraries(tool_read_vector_simple davix test_davix_functional_lib )

add_executable(test_rw_fd ${src_test_valid_write_read_fd})
target_link_libraries(test_rw_fd davix test_davix_functional_lib )

add_executable(test_prop ${src_test_prop} )
target_link_libraries(test_prop davix ${Boost_LIBRARIES} test_davix_functional_lib)

add_executable(test_stat ${src_test_stat})
target_link_libraries(test_stat davix test_davix_functional_lib)

add_executable(test_stat_auto_check ${src_test_auto_stat_mkdir_check})
target_link_libraries(test_stat_auto_check davix test_davix_functional_lib)

add_executable(test_mkdir ${src_test_mkdir})
target_link_libraries(test_mkdir davix test_davix_functional_lib)

add_executable(test_checksum ${src_test_checksum})
target_link_libraries(test_checksum davix test_davix_functional_lib)

add_executable(test_auto_rmdir_unlink_delete ${src_test_auto_rmdir_unlink_delete})
target_link_libraries(test_auto_rmdir_unlink_delete davix test_davix_functional_lib)

add_executable(test_stat_session ${src_test_stat_session})
target_link_libraries(test_stat_session davix test_davix_functional_lib)


add_executable(test_rw ${src_test_rw})
target_link_libraries(test_rw davix test_davix_functional_lib)

add_executable(test_opendir ${src_test_opendir} )
target_link_libraries(test_opendir davix test_davix_functional_lib)

add_executable(test_listing ${src_test_listing} )
target_link_libraries(test_listing davix test_davix_functional_lib)

add_executable(test_directory ${src_test_directory} )
target_link_libraries(test_directory davix test_davix_functional_lib)

add_executable(test_opendir_partial ${src_test_opendir_partial})
target_link_libraries(test_opendir_partial davix test_davix_functional_lib)

add_executable(test_opendirpp ${src_test_opendirpp})
target_link_libraries(test_opendirpp davix test_davix_functional_lib)

add_executable(test_valid_read_generic_simple ${src_test_valid_read_generic_simple})
target_link_libraries(test_valid_read_generic_simple davix test_davix_functional_lib)

add_executable(test_valid_write_read_generic_simple ${src_test_valid_write_read_generic_simple})
target_link_libraries(test_valid_write_read_generic_simple davix test_davix_functional_lib)

add_executable(test_valid_write_read_davfile ${src_test_valid_write_read_davfile})
target_link_libraries(test_valid_write_read_davfile davix test_davix_functional_lib)

add_executable(test_valid_write_read_vector_simple ${src_test_valid_write_read_vector_simple})
target_link_libraries(test_valid_write_read_vector_simple davix test_davix_functional_lib)


add_executable(tool_get_replicas ${src_tool_get_replicas})
target_link_libraries(tool_get_replicas davix test_davix_functional_lib)

add_executable(test_mv ${src_test_mv})
target_link_libraries(test_mv davix test_davix_functional_lib)

function(test_dav_endpoint_ronly name cred)

    add_test(test_stat_${name} test_stat ${name} ${cred})
    add_test(test_stat_session_${name} test_stat_session ${cred} ${name} ${name} ${name} ${name} ${name} ${name} ${name})
    add_test(test_opendir_${name} test_opendir ${name} ${cred})
  #  add_test(test_opendir_c_${name} test_opendir_c ${name} ${cred})
    add_test(test_opendirpp_${name} test_opendirpp ${name} ${cred})
  #  add_test(test_stat_c_${name} test_stat_c ${name} ${cred})
endfunction(test_dav_endpoint_ronly name cred)

function(test_dav_endpoint_rw name cred)

    add_test(test_stat_${name} test_stat ${name} ${cred})
    add_test(test_stat_session_${name} test_stat_session ${cred} ${name} ${name} ${name} ${name} ${name} ${name} ${name})
    add_test(test_opendir_${name} test_opendir ${name} ${cred})
    add_test(test_opendirpp_${name} test_opendirpp ${name} ${cred})
    add_test(test_listing_${name} test_listing ${name} ${cred})
    add_test(test_mkdir_${name} test_mkdir ${name} ${cred})
    add_test(test_stat_auto_check_${name} test_stat_auto_check ${name} ${cred})
endfunction(test_dav_endpoint_rw name cred)

function(listdir_partial name size cred)
    add_test(test_opendir_partial_${name}  test_opendir_partial ${name} ${size} ${cred})
endfunction(listdir_partial name size cred)


function(test_collection name cred)
    add_test(test_directory_${name} test_directory ${name} ${cred})
endfunction(test_collection name cred)

function(test_valid_read_generic url cred)
    add_test(test_valid_read_generic_${url} test_valid_read_generic_simple ${url} ${cred})
endfunction(test_valid_read_generic url cred)

function(test_valid_delete_all url cred)
    add_test(test_auto_rmdir_unlink_delete_${url} test_auto_rmdir_unlink_delete ${url} ${cred})
endfunction(test_valid_delete_all url cred)


function(test_valid_write_read_generic url cred)
    add_test(test_valid_write_read_generic_simple_${url} test_valid_write_read_generic_simple ${url} ${cred})
    add_test(test_rw_fd_${url} test_rw_fd ${url} ${cred})
    add_test(test_valid_write_read_vector_simple_${url} test_valid_write_read_vector_simple ${url} ${cred})
endfunction(test_valid_write_read_generic url cred)

function(test_replica_listing_existing url cred)
   add_test(tool_get_replicas_${url} tool_get_replicas ${url} ${cred})
endfunction(test_replica_listing_existing url cred)

function(test_rename url cred)
    add_test(test_mv_${url} test_mv ${url} ${cred})
endfunction(test_rename url cred)

include(ctest_functional.cmake)

endif(FUNCTIONAL_TESTS)

=== test/root-tests/CMakeLists.txt ===



option(ROOT_TESTS "Root functional test execution " FALSE)

if(ROOT_TESTS)

## the root tests are compatibility tests with the ROOT analysis framework (http://root.cern.ch/)
## The root tests need to be compiled and executed :
## - the ROOT framework
## - a valid proxy credential for the dteam VO


find_package(ROOT REQUIRED)

add_definitions(-Wall)




add_definitions( ${INTERN_ROOT_CONFIG_CFLAGS} -lTreePlayer)
link_directories( ${ROOT_LIBRARY_DIR})
include_directories( ${ROOT_INCLUDE_DIR})
add_executable(test_event "h2fastnew_main.cpp")
target_link_libraries(test_event ${ROOT_LIBRARIES} TreePlayer)



function(test_root_event name url)

    add_test(test_root_event_${name} test_event ${url})
endfunction(test_root_event name url)


## official root website
test_root_event(root_website http://root.cern.ch/files/h1big.root)
## DPM test https
test_root_event(root_DPM_testbed https://lxfsra04a04.cern.ch/dpm/cern.ch/home/dteam/h1big.root)
## Dcache test http
test_root_event(root_dCache_testbed http://vm-dcache-deploy6.desy.de:2881/dteam/h1big.root)


endif(ROOT_TESTS)

=== debian/changelog ===
davix (0.5.0-1build1) xenial; urgency=medium

  * No-change rebuild for gsoap transition.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Feb 2016 07:23:25 +0000

davix (0.5.0-1) unstable; urgency=medium

  * Update to version 0.5.0
  * Add dbg packages

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Wed, 02 Dec 2015 10:38:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: davix
 Priority: optional
 Maintainer: Mattias Ellert <mattias.ellert@fysast.uu.se>
-Build-Depends: debhelper (>= 8.0.0), cmake, libxml2-dev, libssl-dev, gsoap, libgridsite-dev, libboost-system-dev, libboost-thread-dev, rapidjson-dev, libgtest-dev, abi-compliance-checker, pkg-config, doxygen
+Build-Depends: debhelper (>= 8.0.0), cmake, libxml2-dev, libssl-dev, gsoap, libboost-system-dev, libboost-thread-dev, rapidjson-dev, libgtest-dev, abi-compliance-checker, pkg-config, doxygen
 Standards-Version: 3.9.6
 Section: net
 Homepage: http://dmc.web.cern.ch/projects/davix/home
@@ -29,7 +29,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libdavix0v5 (= ${binary:Version})
+Depends: ${misc:Depends}, libdavix0v5 (= ${binary:Version})
 Description: Development files for davix
  Development files for davix. Davix is a toolkit designed for file operations
  with http based protocols (WebDav, Amazon S3, ...).
@@ -42,3 +42,23 @@
 Description: Documentation for davix
  Documentation and examples for davix. Davix is a toolkit designed for file
  operations with Http based protocols (WebDav, Amazon S3, ...).
+
+Package: davix-dbg
+Section: debug
+Priority: extra
+Architecture: any
+Multi-Arch: foreign
+Depends: ${misc:Depends}, davix (= ${binary:Version})
+Description: Debug symbols for the davix tools
+ Debug symbols for the davix tools. Davix is a toolkit designed for
+ file operations with http based protocols (WebDav, Amazon S3, ...).
+
+Package: libdavix-dbg
+Section: debug
+Priority: extra
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends}, libdavix0v5 (= ${binary:Version})
+Description: Debug symbols for the davix library
+ Debug symbols for the davix library. Davix is a toolkit designed for
+ file operations with http based protocols (WebDav, Amazon S3, ...).

=== debian/rules ===
--- 
+++ 
@@ -32,6 +32,10 @@
 	rm debian/tmp/usr/share/doc/davix/LICENSE
 	dh_install --fail-missing
 
+override_dh_strip:
+	dh_strip -X/lib/ --dbg-package davix-dbg
+	dh_strip -X/bin/ --dbg-package libdavix-dbg
+
 override_dh_auto_clean:
 	rm -f test/unit/gtest
 	dh_auto_clean
